VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CAgent"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private mcolChars As Collection
Private WithEvents App As Application
Attribute App.VB_VarHelpID = -1
Private WithEvents moInboxItems As Items
Attribute moInboxItems.VB_VarHelpID = -1

'
' Constructor
'
Private Sub Class_Initialize()
Dim oDir As Scripting.Folder
Dim oFile As Scripting.File
Dim sDir As String

   ' Lookup Folder
   With New FileSystemObject
      sDir = .GetSpecialFolder(WindowsFolder).Path & "\Msagent\Chars"
      Set oDir = .GetFolder(.GetSpecialFolder(WindowsFolder).Path & "\Msagent\Chars")
   End With

   ' Add characters to the collection
   Set mcolChars = New Collection
   For Each oFile In oDir.Files
      If LCase(Right$(oFile.Name, 4)) = ".acs" Then
         Call mcolChars.Add(oFile.Path)
      End If
   Next
   
   If mcolChars.Count = 0 Then
      Call MsgBox("Please install one or more MS Agent characters in folder: " & sDir, vbExclamation)
   Else
            
      Set App = Application
      With ThisOutlookSession.GetNamespace("MAPI").GetDefaultFolder(olFolderInbox)
         Set moInboxItems = .Items
      End With
      
      Call Me.Speak("Master, I am at your service.", False)
   End If
End Sub

'
' Destructor
'
Private Sub Class_Terminate()
   Set mcolChars = Nothing
   Set App = Nothing
End Sub


Public Sub Speak(ByVal vsText As String, ByVal vbBye As Boolean)
Const sCHAR_ID As String = "CharacterID"
Dim oAgent As AgentObjects.Agent
Dim oChar As AgentObjects.IAgentCtlCharacterEx
Dim sChar As String
Dim lChar As Long
Dim r As Double

   On Error GoTo ErrorHandler

   ' Create Agent object
   Set oAgent = New AgentObjects.Agent
   oAgent.Connected = True
   
   ' Determine Character file
   Call Randomize
   r = Rnd()
   lChar = CLng(r * (mcolChars.Count - 1)) + 1
   sChar = mcolChars(lChar)
   
   '
   ' Create Character
   '
   Call oAgent.Characters.Load(sCHAR_ID, sChar)
   Set oChar = oAgent.Characters(sCHAR_ID)
   
   '
   ' Show, Speak, Wave, Hide
   '
   Call oChar.Show
      
   oChar.LanguageID = 1033
   Call oChar.Speak(vsText)
   
   If vbBye Then
      Call oChar.Play("Wave")
      Call oChar.Speak(NoBalloonText("Bye"))
   End If
    
   Call oChar.Hide
   
   While oChar.Active = 2
      DoEvents
   Wend
   
ErrorHandler:
   ' Ignore all errors
   
   Set oChar = Nothing
   Set oAgent = Nothing
   
   Exit Sub
End Sub

'
' Speak without a balloon
'
Private Function NoBalloonText(sText) As String
   NoBalloonText = ("\map=""" & sText & """=""""\")
End Function

'
' Show balloon without speaking
'
Private Function BalloonText(sText) As String
   BalloonText = ("\map=""""=""" & sText & """\")
End Function

'
' Show the Agent and speak the Sender and Subject
'
Private Sub NewMailItem(ByVal voMail As MailItem)
Dim lPos As Long
Dim sSender As String
Dim sSubject As String
Dim sText As String

   '
   ' Sender bepalen
   '
   sSender = voMail.SenderName
   
   ' Alles na @ weg laten (Jan.Jansen@yahoo.com -> Jan.Jansen)
   lPos = InStr(sSender, "@")
   If lPos > 0 Then
      sSender = Left$(sSender, lPos - 1)
   End If
   
   ' Punten vervangen door spatie (Jan.Jansen -> Jan Jansen)
   sSender = Replace(sSender, ".", " ")
   
   ' Omdraaien: Achternaam, Voornaam (Sonnemans, Fons -> Fons Sonnemans)
   lPos = InStr(sSender, ", ")
   If lPos > 0 Then
      sSender = Mid$(sSender, lPos + 1) & " " & Left$(sSender, lPos - 1)
   End If
   
   If Len(Trim(voMail.Subject)) = 0 Then
      sText = sSender + " didn't enter a subject." & sSubject
   Else
      sSubject = LCase$(voMail.Subject)
      sText = sSender + " says: " & sSubject
   End If
   Call Me.Speak(sText, True)
   
End Sub

'
' EventHandler: Item added to the Inbox
'
Private Sub moInboxItems_ItemAdd(ByVal Item As Object)
   
   '
   ' Check whether it is a E-Mail message
   '
   If TypeOf Item Is MailItem Then
      Call NewMailItem(Item)
   End If
End Sub
